/* list.h
 */
/* This software is Copyright (c) 1994-1995 by Wayne Davison.
 *
 * Permission is hereby granted to copy, reproduce, redistribute or otherwise
 * use this software as long as: there is no monetary profit gained
 * specifically from the use or reproduction of this software, it is not
 * sold, rented, traded or otherwise marketed, and this copyright notice is
 * included prominently in any copy made. 
 *
 * The authors make no claims as to the fitness or correctness of this software
 * for any use whatsoever, and it is provided as is. Any use of this software
 * is at the user's own risk. 
 */

struct listnode {
    LISTNODE* next;
    /*LISTNODE* mid;*/
    long low;
    long high;
    char* data_high;
    char data[1];  /* this is actually longer */
};

struct list {
    LISTNODE* first;
    LISTNODE* recent;
    void (*init_node) _((LIST*,LISTNODE*));
    long low;
    long high;
    int item_size;
    int items_per_node;
    int flags;
};

#define LF_ZERO_MEM	0x0001
#define LF_SPARSE	0x0002

/* DON'T EDIT BELOW THIS LINE OR YOUR CHANGES WILL BE LOST! */

void list_init _((void));
LIST* new_list _((long,long,int,int,int,void(*) _((LIST*,LISTNODE*))));
char* listnum2listitem _((LIST*,long));
long listitem2listnum _((LIST*,char*));
bool walk_list _((LIST*,bool(*) _((char*,int)),int));
long existing_listnum _((LIST*,long,int));
char* next_listitem _((LIST*,char*));
char* prev_listitem _((LIST*,char*));
void delete_list _((LIST*));
